from __future__ import with_statement

import es
import os
import re

regex = re.compile('(?:\d{1,3}\.){3}\d{1,3}:\d{1,5}')

def getServerIP():
	int_bits = 24
	int_ip_total = int(es.ServerVar('hostip'))
	str_ip = ''
	for int_count in range(0, 3):
		int_next_part = int_ip_total >> int_bits
		int_ip_total -= int_next_part << int_bits
		int_bits -= 8
		str_ip += '%s.' % (int_next_part & 255)
	str_ip += str(int_ip_total)
	return '%s:%s' % (str_ip, es.ServerVar('hostport'))
	
def getIpWhiteList(path):
	with open(path, 'r') as file:
		return [getServerIP()] + [n for n in file.read().splitlines() if not n.startswith('#')]
	
def removeIpFromString(string):
	for address in regex.findall(string):
		if address not in IPWhiteList:
			string = string.replace(address, re.sub('[0-9]', '*', address))
	return string

def sayFilter(userid, text, teamonly):
	return(userid, removeIpFromString(text.strip('"')), teamonly)

def load():  es.addons.registerSayFilter(sayFilter)
def unload():  es.addons.unregisterSayFilter(sayFilter)

IPWhiteList = getIpWhiteList(os.path.join(es.getAddonPath('ipchatfilter'), 'ipwhitelist.txt'))